;Adobe Helvetica normal
;-------------------------------------------------
;Erstellt die Variable kreisdev nach einem Achsenwert
;-------------------------------------------------

;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;%include "./INC/makekreisdev.inc"

;Kreisx		dd	0	;X-Wert auf der Kreislinie
;Kreisy		dd	0	;Y-Wert auf der Kreislinie
;Kreisz		dd	0	;Z-Wert auf der Kreislinie
;Radius		dd	0

;kreisdev		db	0
;VORHER:############################
;Bit	1 0
;	0 0		Kreis um die Z-Achse		-unchanged
;	0 1		Kreis um die Y-Achse		-unchanged
;	1 0		Kreis um die X-Achse		-unchanged
;	1 1		-

;Bit	2
;	0		linksrum				-unchanged
;	1		rechtsrum				-unchanged

;Bit	4 3
;	0 0		X ist gegeben
;	0 1		Y ist gegeben
;	1 0		Z ist gegeben
;	1 1		-

;Bit	6 5
;	0 0		Kreissektor 1
;	0 1		Kreissektor 2
;	1 0		Kreissektor 4
;	1 1		Kreissektor 3

;DANACH:############################
;Bit	1 0
;	0 0		Kreis um die Z-Achse
;	0 1		Kreis um die Y-Achse
;	1 0		Kreis um die X-Achse
;	1 1		-

;Bit	2
;	0		linksrum
;	1		rechtsrum

;Bit 3=Wert der Achse 1|8 ist 0=(+), 1=(-)
;Bit 4=Wert der Achse 2|3 ist 0=(+), 1=(-)
;Bit	4 3
;	0 0		Kreissektor 1
;	0 1		Kreissektor 2
;	1 0		Kreissektor 4
;	1 1		Kreissektor 3

;Bit	5 4 3				changed
;	0 0 0		Sektor  1
;	0 0 1		Sektor  4
;	0 1 0		Sektor  8
;	0 1 1		Sektor  5
;	1 0 0		Sektor  2
;	1 0 1		Sektor  3
;	1 1 0		Sektor  7
;	1 1 1		Sektor  6

;-------------------------------------------------

makekreisdev:

section .text
	pushad

	mov	edx,0
	mov	eax,[Radius]
	mul	dword[Radius]
	mov	[Wert],eax
	mov	[Wert+4],edx

	mov	bl,[kreisdev]
	and	bl,11000b

	cmp	bl,0					;X ist gegeben nein->
	jz	.a1
	jmp	.a2
.a1:
	mov	edx,0
	mov	eax,[Kreisx]
	mul	dword[Kreisx]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	call	sqrt64

	mov	bl,[kreisdev]
	and	bl,11b

	cmp	bl,0					;Kreis um die Z-Achse
	jz	.b
	jmp	.b1
.b:
	mov	eax,[Ergebnis]
	mov	[Kreisy],eax

	mov	bl,[kreisdev]
	and	bl,1100000b
	and	byte[kreisdev],111b

	test	byte[kreisdev],4
	jz	.ba					;linksrum
	jmp	.ba4
.ba:
	cmp	bl,0					;Kreissektor 1
	jnz	.ba1
	cmp	eax,[Kreisx]
	jae	.bb1
	or	byte[kreisdev],000000b	;sektor 1
	jmp	.ende
.bb1:
	or	byte[kreisdev],100000b	;sektor 2
	jmp	.ende
.ba1:
	cmp	bl,32					;Kreissektor 2
	jnz	.ba2
	cmp	eax,[Kreisx]
	jbe	.bb2
	or	byte[kreisdev],101000b	;sektor 3
	jmp	.ende
.bb2:
	or	byte[kreisdev],001000b	;sektor 4
	jmp	.ende
.ba2:
	cmp	bl,96					;Kreissektor 3
	jnz	.ba3
	cmp	eax,[Kreisx]
	jae	.bb3
	or	byte[kreisdev],011000b	;sektor 5
	jmp	.ende
.bb3:
	or	byte[kreisdev],111000b	;sektor 6
	jmp	.ende
.ba3:							;Kreissektor 4
	cmp	eax,[Kreisx]
	jbe	.bb4
	or	byte[kreisdev],110000b	;sektor 7
	jmp	.ende
.bb4:
	or	byte[kreisdev],010000b	;sektor 8
	jmp	.ende

.ba4:							;rechtsrum
	cmp	bl,0					;Kreissektor 1
	jnz	.ba5
	cmp	eax,[Kreisx]
	jbe	.bb5
	or	byte[kreisdev],100000b	;sektor 2
	jmp	.ende
.bb5:
	or	byte[kreisdev],000000b	;sektor 1
	jmp	.ende
.ba5:
	cmp	bl,32					;Kreissektor 2
	jnz	.ba6
	cmp	eax,[Kreisx]
	jae	.bb6
	or	byte[kreisdev],001000b	;sektor 4
	jmp	.ende
.bb6:
	or	byte[kreisdev],101000b	;sektor 3
	jmp	.ende
.ba6:
	cmp	bl,96					;Kreissektor 3
	jnz	.ba7
	cmp	eax,[Kreisx]
	jbe	.bb7
	or	byte[kreisdev],111000b	;sektor 6
	jmp	.ende
.bb7:
	or	byte[kreisdev],011000b	;sektor 5
	jmp	.ende
.ba7:							;Kreissektor 4
	cmp	eax,[Kreisx]
	jae	.bb8
	or	byte[kreisdev],010000b	;sektor 8
	jmp	.ende
.bb8:
	or	byte[kreisdev],110000b	;sektor 7
	jmp	.ende


.b1:
	cmp	bl,1					;Kreis um die Y-Achse
	jz	.b2
	jmp	.fehler
.b2:
	mov	eax,[Ergebnis]
	mov	[Kreisz],eax

	mov	bl,[kreisdev]
	and	bl,1100000b
	and	byte[kreisdev],111b

	test	byte[kreisdev],4
	jz	.ba8					;linksrum
	jmp	.ba12
.ba8:
	cmp	bl,0					;Kreissektor 1
	jnz	.ba9
	cmp	eax,[Kreisx]
	jae	.bb9
	or	byte[kreisdev],000000b	;sektor 1
	jmp	.ende
.bb9:
	or	byte[kreisdev],100000b	;sektor 2
	jmp	.ende
.ba9:
	cmp	bl,32					;Kreissektor 2
	jnz	.ba10
	cmp	eax,[Kreisx]
	jbe	.bb10
	or	byte[kreisdev],101000b	;sektor 3
	jmp	.ende
.bb10:
	or	byte[kreisdev],001000b	;sektor 4
	jmp	.ende
.ba10:
	cmp	bl,64					;Kreissektor 3
	jnz	.ba11
	cmp	eax,[Kreisx]
	jae	.bb11
	or	byte[kreisdev],011000b	;sektor 5
	jmp	.ende
.bb11:
	or	byte[kreisdev],111000b	;sektor 6
	jmp	.ende
.ba11:
	cmp	bl,96					;Kreissektor 4
	jnz	.ba12
	cmp	eax,[Kreisx]
	jbe	.bb12
	or	byte[kreisdev],110000b	;sektor 7
	jmp	.ende
.bb12:
	or	byte[kreisdev],010000b	;sektor 8
	jmp	.ende

.ba12:						;rechtsrum
	cmp	bl,0					;Kreissektor 1
	jnz	.ba13
	cmp	eax,[Kreisx]
	jbe	.bb13
	or	byte[kreisdev],100000b	;sektor 2
	jmp	.ende
.bb13:
	or	byte[kreisdev],000000b	;sektor 1
	jmp	.ende
.ba13:
	cmp	bl,32					;Kreissektor 2
	jnz	.ba14
	cmp	eax,[Kreisx]
	jae	.bb14
	or	byte[kreisdev],001000b	;sektor 4
	jmp	.ende
.bb14:
	or	byte[kreisdev],101000b	;sektor 3
	jmp	.ende
.ba14:
	cmp	bl,64					;Kreissektor 3
	jnz	.ba15
	cmp	eax,[Kreisx]
	jbe	.bb15
	or	byte[kreisdev],111000b	;sektor 6
	jmp	.ende
.bb15:
	or	byte[kreisdev],011000b	;sektor 5
	jmp	.ende
.ba15:						;Kreissektor 4
	cmp	eax,[Kreisx]
	jae	.bb16
	or	byte[kreisdev],010000b	;sektor 8
	jmp	.ende
.bb16:
	or	byte[kreisdev],110000b	;sektor 7
	jmp	.ende
;-------------------------------------------------
.a2:
	cmp	bl,01000b				;Y ist gegeben nein->
	jz	.a3
	jmp	.a4
.a3:
	mov	edx,0
	mov	eax,[Kreisy]
	mul	dword[Kreisy]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	call	sqrt64

	mov	bl,[kreisdev]
	and	bl,11b

	cmp	bl,0					;Kreis um die Z-Achse
	jz	.c
	jmp	.c1
.c:
	mov	eax,[Ergebnis]
	mov	[Kreisx],eax

	mov	bl,[kreisdev]
	and	bl,1100000b
	and	byte[kreisdev],111b

	test	byte[kreisdev],4
	jz	.ca					;linksrum
	jmp	.ca4
.ca:
	cmp	bl,0					;Kreissektor 1
	jnz	.ca1
	cmp	eax,[Kreisy]
	jbe	.cb1
	or	byte[kreisdev],000000b	;sektor 1
	jmp	.ende
.cb1:
	or	byte[kreisdev],100000b	;sektor 2
	jmp	.ende
.ca1:
	cmp	bl,32					;Kreissektor 2
	jnz	.ca2
	cmp	eax,[Kreisy]
	jae	.cb2
	or	byte[kreisdev],101000b	;sektor 3
	jmp	.ende
.cb2:
	or	byte[kreisdev],001000b	;sektor 4
	jmp	.ende
.ca2:
	cmp	bl,64					;Kreissektor 3
	jnz	.ca3
	cmp	eax,[Kreisy]
	jbe	.cb3
	or	byte[kreisdev],011000b	;sektor 5
	jmp	.ende
.cb3:
	or	byte[kreisdev],111000b	;sektor 6
	jmp	.ende
.ca3:
	cmp	bl,96					;Kreissektor 4
	jnz	.ca4
	cmp	eax,[Kreisy]
	jae	.cb4
	or	byte[kreisdev],110000b	;sektor 7
	jmp	.ende
.cb4:
	or	byte[kreisdev],010000b	;sektor 8
	jmp	.ende

.ca4:							;rechtsrum
	cmp	bl,0					;Kreissektor 1
	jnz	.ca5
	cmp	eax,[Kreisy]
	jae	.cb5
	or	byte[kreisdev],100000b	;sektor 2
	jmp	.ende
.cb5:
	or	byte[kreisdev],000000b	;sektor 1
	jmp	.ende
.ca5:
	cmp	bl,32					;Kreissektor 2
	jnz	.ca6
	cmp	eax,[Kreisy]
	jbe	.cb6
	or	byte[kreisdev],001000b	;sektor 4
	jmp	.ende
.cb6:
	or	byte[kreisdev],101000b	;sektor 3
	jmp	.ende
.ca6:
	cmp	bl,64					;Kreissektor 3
	jnz	.ca7
	cmp	eax,[Kreisy]
	jae	.cb7
	or	byte[kreisdev],111000b	;sektor 6
	jmp	.ende
.cb7:
	or	byte[kreisdev],011000b	;sektor 5
	jmp	.ende
.ca7:							;Kreissektor 4
	cmp	eax,[Kreisy]
	jbe	.cb8
	or	byte[kreisdev],010000b	;sektor 8
	jmp	.ende
.cb8:
	or	byte[kreisdev],110000b	;sektor 7
	jmp	.ende

.c1:
	cmp	bl,2					;Kreis um die X-Achse
	jz	.c2
	jmp	.fehler
.c2:
	mov	eax,[Ergebnis]
	mov	[Kreisz],eax

	mov	bl,[kreisdev]
	and	bl,1100000b
	and	byte[kreisdev],111b

	test	byte[kreisdev],4
	jz	.ca8					;linksrum
	jmp	.ca12
.ca8:
	cmp	bl,0					;Kreissektor 1
	jnz	.ca9
	cmp	eax,[Kreisy]
	jae	.cb9
	or	byte[kreisdev],000000b	;sektor 1
	jmp	.ende
.cb9:
	or	byte[kreisdev],100000b	;sektor 2
	jmp	.ende
.ca9:
	cmp	bl,32					;Kreissektor 2
	jnz	.ca10
	cmp	eax,[Kreisy]
	jbe	.cb10
	or	byte[kreisdev],101000b	;sektor 3
	jmp	.ende
.cb10:
	or	byte[kreisdev],001000b	;sektor 4
	jmp	.ende
.ca10:
	cmp	bl,64					;Kreissektor 3
	jnz	.ca11
	cmp	eax,[Kreisy]
	jae	.cb11
	or	byte[kreisdev],011000b	;sektor 5
	jmp	.ende
.cb11:
	or	byte[kreisdev],111000b	;sektor 6
	jmp	.ende
.ca11:
	cmp	bl,96					;Kreissektor 4
	jnz	.ca12
	cmp	eax,[Kreisy]
	jbe	.cb12
	or	byte[kreisdev],110000b	;sektor 7
	jmp	.ende
.cb12:
	or	byte[kreisdev],010000b	;sektor 8
	jmp	.ende

.ca12:						;rechtsrum
	cmp	bl,0					;Kreissektor 1
	jnz	.ca13
	cmp	eax,[Kreisy]
	jbe	.cb13
	or	byte[kreisdev],100000b	;sektor 2
	jmp	.ende
.cb13:
	or	byte[kreisdev],000000b	;sektor 1
	jmp	.ende
.ca13:
	cmp	bl,32					;Kreissektor 2
	jnz	.ca14
	cmp	eax,[Kreisy]
	jae	.cb14
	or	byte[kreisdev],001000b	;sektor 4
	jmp	.ende
.cb14:
	or	byte[kreisdev],101000b	;sektor 3
	jmp	.ende
.ca14:
	cmp	bl,64					;Kreissektor 3
	jnz	.ca15
	cmp	eax,[Kreisy]
	jbe	.cb15
	or	byte[kreisdev],111000b	;sektor 6
	jmp	.ende
.cb15:
	or	byte[kreisdev],011000b	;sektor 5
	jmp	.ende
.ca15:						;Kreissektor 4
	cmp	eax,[Kreisy]
	jae	.cb16
	or	byte[kreisdev],010000b	;sektor 8
	jmp	.ende
.cb16:
	or	byte[kreisdev],110000b	;sektor 7
	jmp	.ende
;-------------------------------------------------
.a4:
	cmp	bl,10000b				;Z ist gegeben nein->
	jz	.a5
	jmp	.ende
.a5:
	mov	edx,0
	mov	eax,[Kreisz]
	mul	dword[Kreisz]
	sub	[Wert],eax
	sbb	[Wert+4],edx
	call	sqrt64


	mov	bl,[kreisdev]
	and	bl,11b

	cmp	bl,1					;Kreis um die Y-Achse
	jz	.d
	jmp	.d1
.d:
	mov	eax,[Ergebnis]
	mov	[Kreisx],eax

	mov	bl,[kreisdev]
	and	bl,1100000b
	and	byte[kreisdev],111b

	test	byte[kreisdev],4
	jz	.da					;linksrum
	jmp	.da4
.da:
	cmp	bl,0					;Kreissektor 1
	jnz	.da1
	cmp	eax,[Kreisz]
	jbe	.db1
	or	byte[kreisdev],000000b	;sektor 1
	jmp	.ende
.db1:
	or	byte[kreisdev],100000b	;sektor 2
	jmp	.ende
.da1:
	cmp	bl,32					;Kreissektor 2
	jnz	.da2
	cmp	eax,[Kreisz]
	jae	.db2
	or	byte[kreisdev],101000b	;sektor 3
	jmp	.ende
.db2:
	or	byte[kreisdev],001000b	;sektor 4
	jmp	.ende
.da2:
	cmp	bl,64					;Kreissektor 3
	jnz	.da3
	cmp	eax,[Kreisz]
	jbe	.db3
	or	byte[kreisdev],011000b	;sektor 5
	jmp	.ende
.db3:
	or	byte[kreisdev],111000b	;sektor 6
	jmp	.ende
.da3:
	cmp	bl,96					;Kreissektor 4
	jnz	.da4
	cmp	eax,[Kreisz]
	jae	.db4
	or	byte[kreisdev],110000b	;sektor 7
	jmp	.ende
.db4:
	or	byte[kreisdev],010000b	;sektor 8
	jmp	.ende
.da4:							;rechtsrum
	cmp	bl,0					;Kreissektor 1
	jnz	.da5
	cmp	eax,[Kreisz]
	jae	.db5
	or	byte[kreisdev],100000b	;sektor 2
	jmp	.ende
.db5:
	or	byte[kreisdev],000000b	;sektor 1
	jmp	.ende
.da5:
	cmp	bl,32					;Kreissektor 2
	jnz	.da6
	cmp	eax,[Kreisz]
	jbe	.db6
	or	byte[kreisdev],001000b	;sektor 4
	jmp	.ende
.db6:
	or	byte[kreisdev],101000b	;sektor 3
	jmp	.ende
.da6:
	cmp	bl,64					;Kreissektor 3
	jnz	.da7
	cmp	eax,[Kreisz]
	jae	.db7
	or	byte[kreisdev],111000b	;sektor 6
	jmp	.ende
.db7:
	or	byte[kreisdev],011000b	;sektor 5
	jmp	.ende
.da7:							;Kreissektor 4
	cmp	eax,[Kreisz]
	jbe	.db8
	or	byte[kreisdev],010000b	;sektor 8
	jmp	.ende
.db8:
	or	byte[kreisdev],110000b	;sektor 7
	jmp	.ende


.d1:
	cmp	bl,2					;Kreis um die X-Achse
	jz	.d2
	jmp	.fehler
.d2:
	mov	eax,[Ergebnis]
	mov	[Kreisy],eax

	mov	bl,[kreisdev]
	and	bl,1100000b
	and	byte[kreisdev],111b

	test	byte[kreisdev],4
	jz	.da8					;linksrum
	jmp	.da12
.da8:
	cmp	bl,0					;Kreissektor 1
	jnz	.da9
	cmp	eax,[Kreisz]
	jbe	.db9
	or	byte[kreisdev],000000b	;sektor 1
	jmp	.ende
.db9:
	or	byte[kreisdev],100000b	;sektor 2
	jmp	.ende
.da9:
	cmp	bl,32					;Kreissektor 2
	jnz	.da10
	cmp	eax,[Kreisz]
	jae	.db10
	or	byte[kreisdev],101000b	;sektor 3
	jmp	.ende
.db10:
	or	byte[kreisdev],001000b	;sektor 4
	jmp	.ende
.da10:
	cmp	bl,64					;Kreissektor 3
	jnz	.da11
	cmp	eax,[Kreisz]
	jbe	.db11
	or	byte[kreisdev],011000b	;sektor 5
	jmp	.ende
.db11:
	or	byte[kreisdev],111000b	;sektor 6
	jmp	.ende
.da11:
	cmp	bl,96					;Kreissektor 4
	jnz	.da12
	cmp	eax,[Kreisz]
	jae	.db12
	or	byte[kreisdev],110000b	;sektor 7
	jmp	.ende
.db12:
	or	byte[kreisdev],010000b	;sektor 8
	jmp	.ende

.da12:						;rechtsrum
	cmp	bl,0					;Kreissektor 1
	jnz	.da13
	cmp	eax,[Kreisz]
	jae	.db13
	or	byte[kreisdev],100000b	;sektor 2
	jmp	.ende
.db13:
	or	byte[kreisdev],000000b	;sektor 1
	jmp	.ende
.da13:
	cmp	bl,32					;Kreissektor 2
	jnz	.da14
	cmp	eax,[Kreisz]
	jbe	.db14
	or	byte[kreisdev],001000b	;sektor 4
	jmp	.ende
.db14:
	or	byte[kreisdev],101000b	;sektor 3
	jmp	.ende
.da14:
	cmp	bl,64					;Kreissektor 3
	jnz	.da15
	cmp	eax,[Kreisz]
	jae	.db15
	or	byte[kreisdev],111000b	;sektor 6
	jmp	.ende
.db15:
	or	byte[kreisdev],011000b	;sektor 5
	jmp	.ende
.da15:						;Kreissektor 4
	cmp	eax,[Kreisz]
	jbe	.db16
	or	byte[kreisdev],010000b	;sektor 8
	jmp	.ende
.db16:
	or	byte[kreisdev],110000b	;sektor 7
	jmp	.ende

.fehler:
	mov	dword[Kreisx],1
	mov	dword[Kreisy],0
	mov	dword[Kreisz],0
	mov	dword[Radius],1
	mov	byte[kreisdev],0

.ende:
	popad
	ret
